// **********  **********
sbit B_CWKEY at RA5_bit;                //   ()
sbit B_PTT at RA4_bit;                  //  
sbit B_MONI at RC5_bit;                 //   ()
sbit B_USBDET at RC2_bit;               //    USB
bit B_TimeEnd;                          //    
bit B_TimeDot;                          //     
bit B_TimeDash;                         //     
unsigned char UartTmp=0;                //    USART
unsigned int CntAdr=0;                  //      EEPROM
unsigned long CntTime=0;                //    
unsigned long Time=0;                   //    
unsigned short CntTimeDash=0;           //    
unsigned short CountSumb=0;             //    
unsigned short CntSumb=0;               //  
unsigned short Speed=0;                 //   PWM
unsigned short Sumb=0;                  //    
unsigned short RndSumb=0;               //    
unsigned short RndFlag=0;               //        (0x2A) - *

// **********     **********
void Init()
{
  ANSELA=0x00;
  ANSELC=0x00;
  UART1_Init(9600);                     //  UART 9600 bps
  Delay_ms(100);
  RXDTSEL_bit=1;
  TXCKSEL_bit=1;
  PORTA=0x00;                           //  
  PORTC=0x00;
  LATA=0;
  LATC=0;
  TRISA=0b11001110;
  TRISC=0b11011111;
  //    
  T2CON=0b01001000;                     //  1:1  1:10
  PR2=249;                              //      20
  PIR1.TMR2IF=0;                        //    
  PIE1.TMR2IE=1;                        //    
  T2CON.TMR2ON=0;                       //  
  //   
  T4CON=0b01111010;                     //  1:1  1:10
  PR4=48;                               //      20
  PIR3.TMR4IF=0;                        //    
  PIE3.TMR4IE=1;                        //    
  T4CON.TMR4ON=0;                       //  
  //   
  T6CON=0b01111010;                     //  1:1  1:10
  PR6=48;                               //      20
  PIR3.TMR6IF=0;                        //    
  PIE3.TMR6IE=1;                        //    
  T6CON.TMR6ON=0;                       //  
  //   
  INTCON.PEIE=1;                        //    
  INTCON.GIE=1;                         //  
  srand(EEPROM_Read(255));              //        EEPROM
}
void LoadMem()                          //   
{
  CntAdr=0;
  while (B_USBDET==0)                   //    USB
  {
     if (UART1_Data_Ready())            //   
     {
       UartTmp = UART1_Read();          //  
       EEPROM_Write(CntAdr,UartTmp);    //     
       CntAdr++;                        //  
     }
     if (CntAdr>=252)                   //    252 
       {break;}                         //  
  }
}
ReadConfig()                            //   
{
 Speed=EEPROM_Read(0);                  //  
 switch (Speed)                         //     
 {
   case 0:  PR4=255; PR6=255; break;    // 2  WPM
   case 1:  PR4=194; PR6=194; break;    // 3
   case 2:  PR4=145; PR6=145; break;    // 4
   case 3:  PR4=116; PR6=116; break;    // 5
   case 4:  PR4=97;  PR6=97; break;     // 6
   case 5:  PR4=82;  PR6=82; break;     // 7
   case 6:  PR4=72;  PR6=72; break;     // 8
   case 7:  PR4=62;  PR6=62; break;     // 9
   case 8:  PR4=58;  PR6=58; break;     // 10
   case 9:  PR4=53;  PR6=53; break;     // 11
   case 10: PR4=48;  PR6=48; break;     // 12
   case 11: PR4=43;  PR6=43; break;     // 13
   case 12: PR4=40;  PR6=40; break;     // 14
   case 13: PR4=38;  PR6=38; break;     // 15
   case 14: PR4=36;  PR6=36; break;     // 16
   case 15: PR4=33;  PR6=33; break;     // 17
   case 16: PR4=31;  PR6=31; break;     // 18
   case 17: PR4=29;  PR6=29; break;     // 19
   case 18: PR4=28;  PR6=28; break;     // 20
 }
 Time=0;
 Time=EEPROM_Read(1);                   //    
 Time<<8;
 Time+=EEPROM_Read(2);
 Time*=1000;                            //   
 if (Time==0)                           //   0 
 {Time=500;}                            //   
 CountSumb=EEPROM_Read(3);              //   
 RndFlag=EEPROM_Read(4);                //      
                                        // ( 0x2A (*)-   -  )
 if (RndFlag==0x2A)                     //   - 
 {
     unsigned int TmpRnd=0;             //    
     TmpRnd=0 + rand() % ((255 + 1) - 0);
     RndSumb=TmpRnd;
     EEPROM_Write(255,RndSumb);         //      
     //          
 }
}
void TimeDot()                          //    
{
  B_TimeDot=0;                          //    
  T4CON.TMR4ON=1;                       //  
  while (B_TimeDot==0) {asm{ nop;}}     //     
}
void TimeDash()                         //    
{ 
  B_TimeDash=0;                         //    
  CntTimeDash=0;                        //    
  T6CON.TMR6ON=1;                       //   
  while (B_TimeDash==0) {asm{ nop;}}    //     
}
void Dot()                              //   
{
  B_CWKEY=1;                            //  
  B_MONI=1;                             //  
  TimeDot();                            //     
  B_CWKEY=0;                            //  
  B_MONI=0;                             //  
  TimeDot();                            //   (  )
}
void Dash()                             //   
{
  B_CWKEY=1;                            //  
  B_MONI=1;                             //  
  TimeDash();                           //     
  B_CWKEY=0;                            //  
  B_MONI=0;                             //  
  TimeDot();                            //   (  )
}
void PlaySumbol(unsigned short Sumb)    //  
{
  switch (Sumb)                         //     
  {
    case 48: Dash(); Dash(); Dash(); Dash(); Dash(); TimeDash(); break;   // 0
    case 49: Dot(); Dash(); Dash(); Dash(); Dash(); TimeDash(); break;    // 1
    case 50: Dot(); Dot(); Dash(); Dash(); Dash(); TimeDash(); break;     // 2
    case 51: Dot(); Dot(); Dot(); Dash(); Dash(); TimeDash(); break;      // 3
    case 52: Dot(); Dot(); Dot(); Dot(); Dash(); TimeDash(); break;       // 4
    case 53: Dot(); Dot(); Dot(); Dot(); Dot(); TimeDash(); break;        // 5
    case 54: Dash(); Dot(); Dot(); Dot(); Dot(); TimeDash(); break;       // 6
    case 55: Dash(); Dash(); Dot(); Dot(); Dot(); TimeDash(); break;      // 7
    case 56: Dash(); Dash(); Dash(); Dot(); Dot(); TimeDash(); break;     // 8
    case 57: Dash(); Dash(); Dash(); Dash(); Dot(); TimeDash(); break;    // 9
    case 65: Dot(); Dash(); TimeDash(); break;                            // A
    case 66: Dash(); Dot(); Dot(); Dot(); TimeDash(); break;              // B
    case 67: Dash(); Dot(); Dash(); Dot(); TimeDash(); break;             // C
    case 68: Dash(); Dot(); Dot(); TimeDash(); break;                     // D
    case 69: Dot(); TimeDash(); break;                                    // E
    case 70: Dot(); Dot(); Dash(); Dot(); TimeDash(); break;              // F
    case 71: Dash(); Dash(); Dot(); TimeDash(); break;                    // G
    case 72: Dot(); Dot(); Dot(); Dot(); TimeDash(); break;               // H
    case 73: Dot(); Dot(); TimeDash(); break;                             // I
    case 74: Dot(); Dash(); Dash(); Dash(); TimeDash(); break;            // J
    case 75: Dash(); Dot(); Dash(); TimeDash(); break;                    // K
    case 76: Dot(); Dash(); Dot(); Dot(); TimeDash(); break;              // L
    case 77: Dash(); Dash(); TimeDash(); break;                           // M
    case 78: Dash(); Dot(); TimeDash(); break;                            // N
    case 79: Dash(); Dash(); Dash(); TimeDash(); break;                   // O
    case 80: Dot(); Dash(); Dash(); Dot(); TimeDash(); break;             // P
    case 81: Dash(); Dash(); Dot(); Dash(); TimeDash(); break;            // Q
    case 82: Dot(); Dash(); Dot(); TimeDash(); break;                     // R
    case 83: Dot(); Dot(); Dot(); TimeDash(); break;                      // S
    case 84: Dash(); TimeDash(); break;                                   // T
    case 85: Dot(); Dot(); Dash(); TimeDash(); break;                     // U
    case 86: Dot(); Dot(); Dot(); Dash(); TimeDash(); break;              // V
    case 87: Dot(); Dash(); Dash(); TimeDash(); break;                    // W
    case 88: Dash(); Dot(); Dot(); Dash(); TimeDash(); break;             // X
    case 89: Dash(); Dot(); Dash(); Dash(); TimeDash(); break;            // Y
    case 90: Dash(); Dash(); Dot(); Dot(); TimeDash(); break;             // Z
    case 91: Dash(); Dash(); Dash(); Dash(); Dash(); TimeDash(); break;   // 0
    case 92: Dot(); Dash(); Dash(); Dash(); Dash(); TimeDash(); break;    // 1
    case 93: Dot(); Dot(); Dash(); Dash(); Dash(); TimeDash(); break;     // 2
    case 94: Dot(); Dot(); Dot(); Dash(); Dash(); TimeDash(); break;      // 3
    case 95: Dot(); Dot(); Dot(); Dot(); Dash(); TimeDash(); break;       // 4
    case 96: Dot(); Dot(); Dot(); Dot(); Dot(); TimeDash(); break;        // 5
    case 97: Dash(); Dot(); Dot(); Dot(); Dot(); TimeDash(); break;       // 6
    case 98: Dash(); Dash(); Dot(); Dot(); Dot(); TimeDash(); break;      // 7
    case 99: Dash(); Dash(); Dash(); Dot(); Dot(); TimeDash(); break;     // 8
    case 100:Dash(); Dash(); Dash(); Dash(); Dot(); TimeDash(); break;    // 9
    case 63: Dot(); Dot(); Dash(); Dash(); Dot(); Dot(); TimeDash(); break; // ?
    case 47: Dash(); Dot(); Dot(); Dash(); Dot(); TimeDash(); break;      // /
    case 32: TimeDash(); TimeDash(); TimeDot(); break;                    // 
    case 45: B_CWKEY=1; B_MONI=1; Delay_ms(5000); B_CWKEY=0; B_MONI=0; TimeDot(); break; // -   5 
    case 61: B_CWKEY=1; B_MONI=1; Delay_ms(10000); B_CWKEY=0; B_MONI=0; TimeDot(); break; // =   10 
    default: break;
  }
}
void PlayMsg()                          //  
{
  B_PTT=1;                              //  
  Delay_ms(10);
  //    
  for (CntSumb=0; CntSumb<CountSumb+1; CntSumb++)
  {
    Sumb=EEPROM_Read(CntSumb+3);        //   
    PlaySumbol(Sumb);                   //  
  }
  Delay_ms(10);
  B_PTT=0;                              //  
  CntTime=0;                            //   
  T2CON.TMR2ON=1;                       //   
}
unsigned char GetRndNum()
{
     unsigned int TmpRnd=0;
     TmpRnd=65 + rand() % ((100 + 1) - 65);
     RndSumb=TmpRnd;
}
// **********  **********
void interrupt()
{
  if (PIR1.TMR2IF)                      //   
  {
     CntTime+=20;                       //   20 
     if (CntTime>=Time)                 //   
     {
       B_TimeEnd=1;                     //   
       T2CON.TMR2ON=0;                  //   
     }
     PIR1.TMR2IF=0;                     //     
  }
  if (PIR3.TMR4IF)                      //   
  {
     T4CON.TMR4ON=0;                    //  
     B_TimeDot=1;                       //   
     PIR3.TMR4IF=0;                     //     
  }
  if (PIR3.TMR6IF)                      //   
  {
     CntTimeDash++;                     //  
     if (CntTimeDash>=3)                //    
     {
       T6CON.TMR6ON=0;                  //  
       B_TimeDash=1;                    //   
     }
     PIR3.TMR6IF=0;                     //     
  }
}
// **********   **********
void main()                             //  
{
  Init();
  ReadConfig();                         //  
  while(1)
  {
     if (B_USBDET==0)                   //    -  
     {
       if (UART1_Data_Ready())          //    
       {
         UartTmp = UART1_Read();        //    USART
         if (UartTmp==0x52)             //    "R"
         {
           Uart1_Write(0x52);           //  "R"
           LoadMem();                   //    
           ReadConfig();
         }
       }
     }
     if ((B_USBDET==1) && (RndFlag!=0x2A))                   //  
     {
       if (T2CON.TMR2ON==0)             //      -   
       {
         B_TimeEnd=1;                   //    
       }
       if (B_TimeEnd==1)                //    
       {
         PlayMsg();                     //  
         B_TimeEnd=0;
         T2CON.TMR2ON=1;
       }
     }
     if ((B_USBDET==1) && (RndFlag==0x2A))                   //   -  
     {
         B_PTT=1;                       //  
         Delay_ms(10);
         while (B_USBDET==1)            //     
         {
             GetRndNum();
             PlaySumbol(RndSumb);
             GetRndNum();
             PlaySumbol(RndSumb);
             GetRndNum();
             PlaySumbol(RndSumb);
             GetRndNum();
             PlaySumbol(RndSumb);
             GetRndNum();
             PlaySumbol(RndSumb);
             PlaySumbol(32);            //  
         }
         B_PTT=0;                                   //  
         Delay_ms(10);
     }
  }
}