#line 1 "C://CW Mayak 1.1/PO1.2/MyProject.c"

sbit B_CWKEY at RA5_bit;
sbit B_PTT at RA4_bit;
sbit B_MONI at RC5_bit;
sbit B_USBDET at RC2_bit;
bit B_TimeEnd;
bit B_TimeDot;
bit B_TimeDash;
unsigned char UartTmp=0;
unsigned int CntAdr=0;
unsigned long CntTime=0;
unsigned long Time=0;
unsigned short CntTimeDash=0;
unsigned short CountSumb=0;
unsigned short CntSumb=0;
unsigned short Speed=0;
unsigned short Sumb=0;
unsigned short RndSumb=0;
unsigned short RndFlag=0;


void Init()
{
 ANSELA=0x00;
 ANSELC=0x00;
 UART1_Init(9600);
 Delay_ms(100);
 RXDTSEL_bit=1;
 TXCKSEL_bit=1;
 PORTA=0x00;
 PORTC=0x00;
 LATA=0;
 LATC=0;
 TRISA=0b11001110;
 TRISC=0b11011111;

 T2CON=0b01001000;
 PR2=249;
 PIR1.TMR2IF=0;
 PIE1.TMR2IE=1;
 T2CON.TMR2ON=0;

 T4CON=0b01111010;
 PR4=48;
 PIR3.TMR4IF=0;
 PIE3.TMR4IE=1;
 T4CON.TMR4ON=0;

 T6CON=0b01111010;
 PR6=48;
 PIR3.TMR6IF=0;
 PIE3.TMR6IE=1;
 T6CON.TMR6ON=0;

 INTCON.PEIE=1;
 INTCON.GIE=1;
 srand(EEPROM_Read(255));
}
void LoadMem()
{
 CntAdr=0;
 while (B_USBDET==0)
 {
 if (UART1_Data_Ready())
 {
 UartTmp = UART1_Read();
 EEPROM_Write(CntAdr,UartTmp);
 CntAdr++;
 }
 if (CntAdr>=252)
 {break;}
 }
}
ReadConfig()
{
 Speed=EEPROM_Read(0);
 switch (Speed)
 {
 case 0: PR4=255; PR6=255; break;
 case 1: PR4=194; PR6=194; break;
 case 2: PR4=145; PR6=145; break;
 case 3: PR4=116; PR6=116; break;
 case 4: PR4=97; PR6=97; break;
 case 5: PR4=82; PR6=82; break;
 case 6: PR4=72; PR6=72; break;
 case 7: PR4=62; PR6=62; break;
 case 8: PR4=58; PR6=58; break;
 case 9: PR4=53; PR6=53; break;
 case 10: PR4=48; PR6=48; break;
 case 11: PR4=43; PR6=43; break;
 case 12: PR4=40; PR6=40; break;
 case 13: PR4=38; PR6=38; break;
 case 14: PR4=36; PR6=36; break;
 case 15: PR4=33; PR6=33; break;
 case 16: PR4=31; PR6=31; break;
 case 17: PR4=29; PR6=29; break;
 case 18: PR4=28; PR6=28; break;
 }
 Time=0;
 Time=EEPROM_Read(1);
 Time<<8;
 Time+=EEPROM_Read(2);
 Time*=1000;
 if (Time==0)
 {Time=500;}
 CountSumb=EEPROM_Read(3);
 RndFlag=EEPROM_Read(4);

 if (RndFlag==0x2A)
 {
 unsigned int TmpRnd=0;
 TmpRnd=0 + rand() % ((255 + 1) - 0);
 RndSumb=TmpRnd;
 EEPROM_Write(255,RndSumb);

 }
}
void TimeDot()
{
 B_TimeDot=0;
 T4CON.TMR4ON=1;
 while (B_TimeDot==0) {asm{ nop;}}
}
void TimeDash()
{
 B_TimeDash=0;
 CntTimeDash=0;
 T6CON.TMR6ON=1;
 while (B_TimeDash==0) {asm{ nop;}}
}
void Dot()
{
 B_CWKEY=1;
 B_MONI=1;
 TimeDot();
 B_CWKEY=0;
 B_MONI=0;
 TimeDot();
}
void Dash()
{
 B_CWKEY=1;
 B_MONI=1;
 TimeDash();
 B_CWKEY=0;
 B_MONI=0;
 TimeDot();
}
void PlaySumbol(unsigned short Sumb)
{
 switch (Sumb)
 {
 case 48: Dash(); Dash(); Dash(); Dash(); Dash(); TimeDash(); break;
 case 49: Dot(); Dash(); Dash(); Dash(); Dash(); TimeDash(); break;
 case 50: Dot(); Dot(); Dash(); Dash(); Dash(); TimeDash(); break;
 case 51: Dot(); Dot(); Dot(); Dash(); Dash(); TimeDash(); break;
 case 52: Dot(); Dot(); Dot(); Dot(); Dash(); TimeDash(); break;
 case 53: Dot(); Dot(); Dot(); Dot(); Dot(); TimeDash(); break;
 case 54: Dash(); Dot(); Dot(); Dot(); Dot(); TimeDash(); break;
 case 55: Dash(); Dash(); Dot(); Dot(); Dot(); TimeDash(); break;
 case 56: Dash(); Dash(); Dash(); Dot(); Dot(); TimeDash(); break;
 case 57: Dash(); Dash(); Dash(); Dash(); Dot(); TimeDash(); break;
 case 65: Dot(); Dash(); TimeDash(); break;
 case 66: Dash(); Dot(); Dot(); Dot(); TimeDash(); break;
 case 67: Dash(); Dot(); Dash(); Dot(); TimeDash(); break;
 case 68: Dash(); Dot(); Dot(); TimeDash(); break;
 case 69: Dot(); TimeDash(); break;
 case 70: Dot(); Dot(); Dash(); Dot(); TimeDash(); break;
 case 71: Dash(); Dash(); Dot(); TimeDash(); break;
 case 72: Dot(); Dot(); Dot(); Dot(); TimeDash(); break;
 case 73: Dot(); Dot(); TimeDash(); break;
 case 74: Dot(); Dash(); Dash(); Dash(); TimeDash(); break;
 case 75: Dash(); Dot(); Dash(); TimeDash(); break;
 case 76: Dot(); Dash(); Dot(); Dot(); TimeDash(); break;
 case 77: Dash(); Dash(); TimeDash(); break;
 case 78: Dash(); Dot(); TimeDash(); break;
 case 79: Dash(); Dash(); Dash(); TimeDash(); break;
 case 80: Dot(); Dash(); Dash(); Dot(); TimeDash(); break;
 case 81: Dash(); Dash(); Dot(); Dash(); TimeDash(); break;
 case 82: Dot(); Dash(); Dot(); TimeDash(); break;
 case 83: Dot(); Dot(); Dot(); TimeDash(); break;
 case 84: Dash(); TimeDash(); break;
 case 85: Dot(); Dot(); Dash(); TimeDash(); break;
 case 86: Dot(); Dot(); Dot(); Dash(); TimeDash(); break;
 case 87: Dot(); Dash(); Dash(); TimeDash(); break;
 case 88: Dash(); Dot(); Dot(); Dash(); TimeDash(); break;
 case 89: Dash(); Dot(); Dash(); Dash(); TimeDash(); break;
 case 90: Dash(); Dash(); Dot(); Dot(); TimeDash(); break;
 case 91: Dash(); Dash(); Dash(); Dash(); Dash(); TimeDash(); break;
 case 92: Dot(); Dash(); Dash(); Dash(); Dash(); TimeDash(); break;
 case 93: Dot(); Dot(); Dash(); Dash(); Dash(); TimeDash(); break;
 case 94: Dot(); Dot(); Dot(); Dash(); Dash(); TimeDash(); break;
 case 95: Dot(); Dot(); Dot(); Dot(); Dash(); TimeDash(); break;
 case 96: Dot(); Dot(); Dot(); Dot(); Dot(); TimeDash(); break;
 case 97: Dash(); Dot(); Dot(); Dot(); Dot(); TimeDash(); break;
 case 98: Dash(); Dash(); Dot(); Dot(); Dot(); TimeDash(); break;
 case 99: Dash(); Dash(); Dash(); Dot(); Dot(); TimeDash(); break;
 case 100:Dash(); Dash(); Dash(); Dash(); Dot(); TimeDash(); break;
 case 63: Dot(); Dot(); Dash(); Dash(); Dot(); Dot(); TimeDash(); break;
 case 47: Dash(); Dot(); Dot(); Dash(); Dot(); TimeDash(); break;
 case 32: TimeDash(); TimeDash(); TimeDot(); break;
 case 45: B_CWKEY=1; B_MONI=1; Delay_ms(5000); B_CWKEY=0; B_MONI=0; TimeDot(); break;
 case 61: B_CWKEY=1; B_MONI=1; Delay_ms(10000); B_CWKEY=0; B_MONI=0; TimeDot(); break;
 default: break;
 }
}
void PlayMsg()
{
 B_PTT=1;
 Delay_ms(10);

 for (CntSumb=0; CntSumb<CountSumb+1; CntSumb++)
 {
 Sumb=EEPROM_Read(CntSumb+3);
 PlaySumbol(Sumb);
 }
 Delay_ms(10);
 B_PTT=0;
 CntTime=0;
 T2CON.TMR2ON=1;
}
unsigned char GetRndNum()
{
 unsigned int TmpRnd=0;
 TmpRnd=65 + rand() % ((100 + 1) - 65);
 RndSumb=TmpRnd;
}

void interrupt()
{
 if (PIR1.TMR2IF)
 {
 CntTime+=20;
 if (CntTime>=Time)
 {
 B_TimeEnd=1;
 T2CON.TMR2ON=0;
 }
 PIR1.TMR2IF=0;
 }
 if (PIR3.TMR4IF)
 {
 T4CON.TMR4ON=0;
 B_TimeDot=1;
 PIR3.TMR4IF=0;
 }
 if (PIR3.TMR6IF)
 {
 CntTimeDash++;
 if (CntTimeDash>=3)
 {
 T6CON.TMR6ON=0;
 B_TimeDash=1;
 }
 PIR3.TMR6IF=0;
 }
}

void main()
{
 Init();
 ReadConfig();
 while(1)
 {
 if (B_USBDET==0)
 {
 if (UART1_Data_Ready())
 {
 UartTmp = UART1_Read();
 if (UartTmp==0x52)
 {
 Uart1_Write(0x52);
 LoadMem();
 ReadConfig();
 }
 }
 }
 if ((B_USBDET==1) && (RndFlag!=0x2A))
 {
 if (T2CON.TMR2ON==0)
 {
 B_TimeEnd=1;
 }
 if (B_TimeEnd==1)
 {
 PlayMsg();
 B_TimeEnd=0;
 T2CON.TMR2ON=1;
 }
 }
 if ((B_USBDET==1) && (RndFlag==0x2A))
 {
 B_PTT=1;
 Delay_ms(10);
 while (B_USBDET==1)
 {
 GetRndNum();
 PlaySumbol(RndSumb);
 GetRndNum();
 PlaySumbol(RndSumb);
 GetRndNum();
 PlaySumbol(RndSumb);
 GetRndNum();
 PlaySumbol(RndSumb);
 GetRndNum();
 PlaySumbol(RndSumb);
 PlaySumbol(32);
 }
 B_PTT=0;
 Delay_ms(10);
 }
 }
}
